OGRE: Ogre::Light Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Light Class Reference
Core » Scene

Representation of a dynamic light source in the scene. More...

`#include <OgreLight.h>`

Inheritance diagram for Ogre::Light:
[legend]

## Public Types
enum | LightTypes : uint8 { LT_POINT = 0 , LT_DIRECTIONAL = 1 , LT_SPOTLIGHT = 2 , LT_RECTLIGHT = 3 }
| Defines the type of light. More...
Public Types inherited from Ogre::ShadowCaster
typedef Ogre::ShadowRenderableList | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator

## Public Member Functions
| Light ()
| Default constructor (for Python mainly).
| Light (const String &name)
| Normal constructor.
| ~Light ()
| Standard destructor.
void | _calcTempSquareDist (const Vector3 &worldPos)
| internal method for calculating current squared distance from some world position
Real | _deriveShadowFarClipDistance () const
| Derive a shadow camera far distance.
Real | _deriveShadowFarClipDistance (const Camera *) const
Real | _deriveShadowNearClipDistance (const Camera *maincam) const
| Derive a shadow camera near distance from either the light, or from the main camera if the light doesn't have its own setting.
virtual const PlaneBoundedVolumeList & | _getFrustumClipVolumes (const Camera *const cam) const
| Internal method for calculating the clip volumes outside of the frustum which can be used to determine which objects are casting shadow on the frustum as a whole.
size_t | _getIndexInFrame () const
| Returns the index at which this light is in the current render.
virtual const PlaneBoundedVolume & | _getNearClipVolume (const Camera *const cam) const
| Internal method for calculating the 'near clip volume', which is the volume formed between the near clip rectangle of the camera and the light.
void | _notifyAttached (Node *parent, bool isTagPoint=false) override
| Internal method called to notify the object that it has been attached to a node.
void | _notifyIndexInFrame (size_t i)
void | _notifyMoved (void) override
| Internal method called to notify the object that it has been moved.
void | _setCameraRelative (Camera *cam)
| Set the camera which this light should be relative to, for camera-relative rendering.
virtual void | _updateCustomGpuParameter (uint16 paramIndex, const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Light knows.
void | _updateRenderQueue (RenderQueue *queue) override
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
AnimableValuePtr | createAnimableValue (const String &valueName) override
| Create a reference-counted AnimableValuePtr for the named value.
Vector4 | getAs4DVector (bool cameraRelativeIfSet=false) const
| Returns the details of this light as a 4D vector.
const Vector4f & | getAttenuation () const
| Returns all the attenuation params as (range, constant, linear, quadratic).
float | getAttenuationConstant (void) const
| Returns the constant factor in the attenuation formula.
float | getAttenuationLinear (void) const
| Returns the linear factor in the attenuation formula.
float | getAttenuationQuadric (void) const
| Returns the quadric factor in the attenuation formula.
float | getAttenuationRange (void) const
| Returns the absolute upper range of the light.
const AxisAlignedBox & | getBoundingBox (void) const override
| Retrieves the local axis-aligned bounding box for this object.
Real | getBoundingRadius (void) const override
| Retrieves the radius of the origin-centered bounding sphere for this object.
const Vector4f & | getCustomParameter (uint16 index) const
| Returns the custom value associated with this Light at the given index.
const ShadowCameraSetupPtr & | getCustomShadowCameraSetup (void) const
| Return a pointer to the custom shadow camera setup (null means use SceneManager global version).
const Vector3 & | getDerivedDirection (void) const
| Retrieves the direction of the light including any transform from nodes it is attached to.
const Vector3 & | getDerivedPosition (bool cameraRelativeIfSet=false) const
| Retrieves the position of the light including any transform from nodes it is attached to.
Vector3f | getDerivedSourceHalfHeight () const
| The height half vector of the source in world space.
Vector3f | getDerivedSourceHalfWidth () const
| The width half vector of the source in world space.
const ColourValue & | getDiffuseColour (void) const
| Returns the colour of the diffuse light given off by this light source (see setDiffuseColour for more info).
const Vector3 & | getDirection (void) const
const String & | getMovableType (void) const override
| Returns the type name of this object.
const Vector3 & | getPosition (void) const
| Returns the position of the light.
Real | getPowerScale (void) const
| Returns the scaling factor which indicates the relative power of a light.
Real | getShadowFarClipDistance () const
| Returns the far clip plane distance to be used by the shadow camera, if this light casts texture shadows.
Real | getShadowFarDistance (void) const
| Returns the maximum distance away from the camera that shadows by this light will be visible.
Real | getShadowFarDistanceSquared (void) const
Real | getShadowNearClipDistance () const
| Returns the near clip plane distance to be used by the shadow camera, if this light casts texture shadows.
Vector2f | getSourceSize () const
const ColourValue & | getSpecularColour (void) const
| Returns the colour of specular light given off by this light source.
Real | getSpotlightFalloff (void) const
| Returns the falloff between the inner and outer cones of the spotlight.
const Radian & | getSpotlightInnerAngle (void) const
| Returns the angle covered by the spotlights inner cone.
Real | getSpotlightNearClipDistance () const
| Returns the near clip plane distance to be used by spotlights that use light clipping.
const Radian & | getSpotlightOuterAngle (void) const
| Returns the angle covered by the spotlights outer cone.
LightTypes | getType (void) const
| Returns the light type.
uint32 | getTypeFlags (void) const override
| Override to return specific type flag.
bool | isInLightRange (const Ogre::AxisAlignedBox &container) const
| Check whether a bounding box is included in the lighted area of the light.
bool | isInLightRange (const Ogre::Sphere &sphere) const
| Check whether a sphere is included in the lighted area of the light.
void | resetCustomShadowCameraSetup (void)
| Reset the shadow camera setup to the default.
void | resetShadowFarDistance (void)
| Tells the light to use the shadow far distance of the SceneManager.
void | setAttenuation (float range, float constant, float linear, float quadratic)
| Sets the attenuation parameters of the light source i.e.
void | setCustomParameter (uint16 index, const Vector4f &value)
| Sets a custom parameter for this Light, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
void | setCustomShadowCameraSetup (const ShadowCameraSetupPtr &customShadowSetup)
| Set this light to use a custom shadow camera when rendering texture shadows.
void | setDiffuseColour (const ColourValue &colour)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setDiffuseColour (float red, float green, float blue)
| Sets the colour of the diffuse light given off by this source.
void | setDirection (const Vector3 &vec)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setDirection (Real x, Real y, Real z)
void | setPosition (const Vector3 &vec)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setPosition (Real x, Real y, Real z)
| Sets the position of the light.
void | setPowerScale (Real power)
| Set a scaling factor to indicate the relative power of a light.
void | setShadowFarClipDistance (Real farClip)
| Set the far clip plane distance to be used by the shadow camera, if this light casts texture shadows.
void | setShadowFarDistance (Real distance)
| Sets the maximum distance away from the camera that shadows by this light will be visible.
void | setShadowNearClipDistance (Real nearClip)
| Set the near clip plane distance to be used by the shadow camera, if this light casts texture shadows.
void | setSourceSize (float width, float height)
| Sets the size of the area covered by a area light.
void | setSpecularColour (const ColourValue &colour)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setSpecularColour (float red, float green, float blue)
| Sets the colour of the specular light given off by this source.
void | setSpotlightFalloff (Real val)
| Sets the falloff between the inner and outer cones of the spotlight.
void | setSpotlightInnerAngle (const Radian &val)
| Sets the angle covered by the spotlights inner cone.
void | setSpotlightNearClipDistance (Real nearClip)
| Set the near clip plane distance to be used by spotlights that use light clipping, allowing you to render spots as if they start from further down their frustum.
void | setSpotlightOuterAngle (const Radian &val)
| Sets the angle covered by the spotlights outer cone.
void | setSpotlightRange (const Radian &innerAngle, const Radian &outerAngle, Real falloff=2.0)
| Sets the range of a spotlight, i.e.
void | setType (LightTypes type)
| Sets the type of light - see LightTypes for more info.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false) override
| Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject ()
| Constructor.
| MovableObject (const String &name)
| Named constructor.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const Affine3 & | _getParentNodeFullTransform (void) const
| Return the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual void | _notifyCurrentCamera (Camera *cam)
| Internal method to notify the object of the camera to be used for the next rendering operation.
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
Real | getBoundingRadiusScaled () const
| as getBoundingRadius, but with scaling applied
bool | getCastShadows (void) const override
| Returns whether shadow casting is enabled for this object.
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener (void) const
| Gets the current listener for this object.
const String & | getName (void) const
| Returns the name of this object.
Node * | getParentNode (void) const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
Real | getPointExtrusionDistance (const Light *l) const override
| Get the distance to extrude for a point/spot light.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
bool | getReceivesShadows ()
| Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const override
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
bool | isParentTagPoint () const
| Gets whether the parent node is a TagPoint (or a SceneNode).
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)
| Sets the render queue group and group priority this entity will be rendered through.
void | setUserAny (const Any &anything)
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::ShadowCaster
virtual | ~ShadowCaster ()
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Gets the world space bounding box of the dark cap, as extruded using the light provided.
virtual EdgeData * | getEdgeList (void)
| Returns details of the edges which might be used to determine a silhouette.
const AxisAlignedBox & | getLightCapBounds (void) const
| Gets the world space bounding box of the light cap.
virtual const ShadowRenderableList & | getShadowVolumeRenderableList (const Light *light, const HardwareIndexBufferPtr &indexBuffer, size_t &indexBufferUsedSize, float extrusionDistance, int flags=0)
| Gets an list of the renderables required to render the shadow volume.
bool | hasEdgeList ()
| Returns whether the object has a valid edge list.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.

## Public Attributes
Real | tempSquareDist
| Temp tag used for sorting.

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::MovableObject
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
Static Public Member Functions inherited from Ogre::ShadowCaster
static void | clearShadowRenderableList (ShadowRenderableList &shadowRenderables)
| Common implementation of releasing shadow renderables.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.

## Detailed Description

Representation of a dynamic light source in the scene.

Lights are added to the scene like any other object. They contain various parameters like type, attenuation (how light intensity fades with distance), colour etc.

The light colour is computed based on the Direct3D Light Model as:

\[ L_d = C_d \cdot p \cdot ( N \cdot L_{dir}) \cdot A \cdot S \]

\[ L_s = C_s \cdot p \cdot ( N \cdot H)^s \cdot A \cdot S \]

where

\[ A = \frac{1}{c + l \cdot d + q \cdot d^2} \]

and only computed when attenuation is enabled,

\[ S = \left[ \frac{\rho - cos(0.5 \cdot \phi)}{cos(0.5 \cdot \theta) - cos(0.5 \cdot \phi)} \right]^f \]

and only computed with spotlights

- \(C_d\) is the light diffuse colour
- \(C_s\) is the light specular colour
- \(p\) is the light power scale factor
- \(s\) is the surface shininess
- \(N\) is the current surface normal
- \(L_{dir}\) is vector from the vertex position to the light (constant for directional lights)
- \(H = normalised(L_{dir} + V)\), where V is the vector from the vertex position to the camera
- \(c, l, q\) are the constant, linear and quadratic attenuation factors
- \(d = |L_{dir}|\)
- \(\theta, \phi, f\) are the spotlight inner angle, outer angle and falloff
- \(\rho = \langle L_{dir} , L_{dcs} \rangle \) where \(L_{dcs}\) is the light direction in camera space

The defaults when a light is created is pure white diffuse light, with no attenuation (does not decrease with distance) and a range of 1000 world units.

Lights are created by using the SceneManager::createLight method. They subsequently must be added to a SceneNode to orient them in the scene and to allow moving them.

Remember also that dynamic lights rely on modifying the colour of vertices based on the position of the light compared to an object's vertex normals. Dynamic lighting will only look good if the object being lit has a fair level of tessellation and the normals are properly set. This is particularly true for the spotlight which will only look right on highly tessellated models. In the future OGRE may be extended for certain scene types so an alternative to the standard dynamic lighting may be used, such as dynamic lightmaps.

## Member Enumeration Documentation

## ◆ LightTypes

enum Ogre::Light::LightTypes : uint8

Defines the type of light.

Enumerator
LT_POINT | Point light sources give off light equally in all directions, so require only position not direction.
LT_DIRECTIONAL | Directional lights simulate parallel light beams from a distant source, hence have direction but no position.
LT_SPOTLIGHT | Spotlights simulate a cone of light from a source so require position and direction, plus extra values for falloff.
LT_RECTLIGHT | A rectangular area light, requires position, direction, width and height.

## Constructor & Destructor Documentation

## ◆ Light() [1/2]

Ogre::Light::Light | ( |  | ) |

Default constructor (for Python mainly).

## ◆ Light() [2/2]

Ogre::Light::Light | ( | const String & | name | ) |

Normal constructor.

Should not be called directly, but rather the SceneManager::createLight method should be used.

## ◆ ~Light()

Ogre::Light::~Light | ( |  | ) |

Standard destructor.

## Member Function Documentation

## ◆ _calcTempSquareDist()

void Ogre::Light::_calcTempSquareDist | ( | const Vector3 & | worldPos | ) |

internal method for calculating current squared distance from some world position

## ◆ setType()

void Ogre::Light::setType | ( | LightTypes | type | ) |

Sets the type of light - see LightTypes for more info.

## ◆ getType()

LightTypes Ogre::Light::getType | ( | void |  | ) | const

Returns the light type.

## ◆ setDiffuseColour() [1/2]

void Ogre::Light::setDiffuseColour | ( | float | red,
|  | float | green,
|  | float | blue )

Sets the colour of the diffuse light given off by this source.

Material objects have ambient, diffuse and specular values which indicate how much of each type of light an object reflects. This value denotes the amount and colour of this type of light the light exudes into the scene. The actual appearance of objects is a combination of the two.

  Diffuse light simulates the typical light emanating from light sources and affects the base colour of objects together with ambient light.

## ◆ setDiffuseColour() [2/2]

void Ogre::Light::setDiffuseColour | ( | const ColourValue & | colour | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ getDiffuseColour()

const ColourValue & Ogre::Light::getDiffuseColour | ( | void |  | ) | const

Returns the colour of the diffuse light given off by this light source (see setDiffuseColour for more info).

## ◆ setSpecularColour() [1/2]

void Ogre::Light::setSpecularColour | ( | float | red,
|  | float | green,
|  | float | blue )

Sets the colour of the specular light given off by this source.

Material objects have ambient, diffuse and specular values which indicate how much of each type of light an object reflects. This value denotes the amount and colour of this type of light the light exudes into the scene. The actual appearance of objects is a combination of the two.

  Specular light affects the appearance of shiny highlights on objects, and is also dependent on the 'shininess' Material value.

## ◆ setSpecularColour() [2/2]

void Ogre::Light::setSpecularColour | ( | const ColourValue & | colour | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ getSpecularColour()

const ColourValue & Ogre::Light::getSpecularColour | ( | void |  | ) | const

Returns the colour of specular light given off by this light source.

## ◆ setAttenuation()

void Ogre::Light::setAttenuation | ( | float | range,
|  | float | constant,
|  | float | linear,
|  | float | quadratic )
| inline

Sets the attenuation parameters of the light source i.e.

how it diminishes with distance.

Lights normally get fainter the further they are away. Also, each light is given a maximum range beyond which it cannot affect any objects.

  Light attenuation is not applicable to directional lights since they have an infinite range and constant intensity.

  This follows a standard attenuation approach - see any good 3D text for the details of what they mean since i don't have room here!

Parameters

  range | The absolute upper range of the light in world units.
  constant | The constant factor in the attenuation formula: 1.0 means never attenuate, 0.0 is complete attenuation.
  linear | The linear factor in the attenuation formula: 1 means attenuate evenly over the distance.
  quadratic | The quadratic factor in the attenuation formula: adds a curvature to the attenuation formula.

## ◆ getAttenuationRange()

float Ogre::Light::getAttenuationRange | ( | void |  | ) | const
| inline

Returns the absolute upper range of the light.

## ◆ getAttenuationConstant()

float Ogre::Light::getAttenuationConstant | ( | void |  | ) | const
| inline

Returns the constant factor in the attenuation formula.

## ◆ getAttenuationLinear()

float Ogre::Light::getAttenuationLinear | ( | void |  | ) | const
| inline

Returns the linear factor in the attenuation formula.

## ◆ getAttenuationQuadric()

float Ogre::Light::getAttenuationQuadric | ( | void |  | ) | const
| inline

Returns the quadric factor in the attenuation formula.

## ◆ getAttenuation()

const Vector4f & Ogre::Light::getAttenuation | ( |  | ) | const
| inline

Returns all the attenuation params as (range, constant, linear, quadratic).

## ◆ setPosition() [1/2]

void Ogre::Light::setPosition | ( | Real | x,
|  | Real | y,
|  | Real | z )

Sets the position of the light.

Applicable to point lights and spotlights only.

Note
  This will be overridden if the light is attached to a SceneNode.

Deprecated
  attach to SceneNode and use SceneNode::setPosition

## ◆ setPosition() [2/2]

void Ogre::Light::setPosition | ( | const Vector3 & | vec | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Deprecated
  attach to SceneNode and use SceneNode::setPosition

## ◆ getPosition()

const Vector3 & Ogre::Light::getPosition | ( | void |  | ) | const

Returns the position of the light.

Note
  Applicable to point lights and spotlights only.

Deprecated
  attach to SceneNode and use SceneNode::getPosition

## ◆ setDirection() [1/2]

void Ogre::Light::setDirection | ( | Real | x,
|  | Real | y,
|  | Real | z )

Deprecated
  attach to SceneNode and use SceneNode::setDirection

## ◆ setDirection() [2/2]

void Ogre::Light::setDirection | ( | const Vector3 & | vec | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Deprecated
  attach to SceneNode and use SceneNode::setDirection

## ◆ getDirection()

const Vector3 & Ogre::Light::getDirection | ( | void |  | ) | const

Deprecated
  attach to SceneNode and use SceneNode::getLocalAxes

## ◆ _notifyAttached()

void Ogre::Light::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = false )
| overridevirtual

Internal method called to notify the object that it has been attached to a node.

Reimplemented from Ogre::MovableObject.

## ◆ _notifyMoved()

void Ogre::Light::_notifyMoved | ( | void |  | ) |
| overridevirtual

Internal method called to notify the object that it has been moved.

Reimplemented from Ogre::MovableObject.

Reimplemented in Ogre::PCZLight.

## ◆ setSpotlightRange()

void Ogre::Light::setSpotlightRange | ( | const Radian & | innerAngle,
|  | const Radian & | outerAngle,
|  | Real | falloff = 2.0 )

Sets the range of a spotlight, i.e.

the angle of the inner and outer cones and the rate of falloff between them.

Parameters

  innerAngle | Angle covered by the bright inner cone

Note
  The inner cone applicable only to Direct3D, it'll always treat as zero in OpenGL.

Parameters

  outerAngle | Angle covered by the outer cone
  falloff | The falloff exponent between the inner and outer cones. 1.0 means a linear falloff, less means slower falloff, 2.0 means quadratic falloff.

## ◆ getSpotlightInnerAngle()

const Radian & Ogre::Light::getSpotlightInnerAngle | ( | void |  | ) | const

Returns the angle covered by the spotlights inner cone.

## ◆ getSpotlightOuterAngle()

const Radian & Ogre::Light::getSpotlightOuterAngle | ( | void |  | ) | const

Returns the angle covered by the spotlights outer cone.

## ◆ getSpotlightFalloff()

Real Ogre::Light::getSpotlightFalloff | ( | void |  | ) | const

Returns the falloff between the inner and outer cones of the spotlight.

## ◆ setSpotlightInnerAngle()

void Ogre::Light::setSpotlightInnerAngle | ( | const Radian & | val | ) |

Sets the angle covered by the spotlights inner cone.

## ◆ setSpotlightOuterAngle()

void Ogre::Light::setSpotlightOuterAngle | ( | const Radian & | val | ) |

Sets the angle covered by the spotlights outer cone.

## ◆ setSpotlightFalloff()

void Ogre::Light::setSpotlightFalloff | ( | Real | val | ) |

Sets the falloff between the inner and outer cones of the spotlight.

## ◆ setSpotlightNearClipDistance()

void Ogre::Light::setSpotlightNearClipDistance | ( | Real | nearClip | ) |
| inline

Set the near clip plane distance to be used by spotlights that use light clipping, allowing you to render spots as if they start from further down their frustum.

Parameters

  nearClip | The near distance.

## ◆ getSpotlightNearClipDistance()

Real Ogre::Light::getSpotlightNearClipDistance | ( |  | ) | const
| inline

Returns the near clip plane distance to be used by spotlights that use light clipping.

## ◆ setSourceSize()

void Ogre::Light::setSourceSize | ( | float | width,
|  | float | height )
| inline

Sets the size of the area covered by a area light.

## ◆ getSourceSize()

Vector2f Ogre::Light::getSourceSize | ( |  | ) | const
| inline

## ◆ getDerivedSourceHalfWidth()

Vector3f Ogre::Light::getDerivedSourceHalfWidth | ( |  | ) | const

The width half vector of the source in world space.

## ◆ getDerivedSourceHalfHeight()

Vector3f Ogre::Light::getDerivedSourceHalfHeight | ( |  | ) | const

The height half vector of the source in world space.

## ◆ setPowerScale()

void Ogre::Light::setPowerScale | ( | Real | power | ) |

Set a scaling factor to indicate the relative power of a light.

This factor is only useful in High Dynamic Range (HDR) rendering. You can bind it to a shader variable to take it into account,

See also
  GpuProgramParameters

Parameters

  power | The power rating of this light, default is 1.0.

## ◆ getPowerScale()

Real Ogre::Light::getPowerScale | ( | void |  | ) | const

Returns the scaling factor which indicates the relative power of a light.

## ◆ getBoundingRadius()

Real Ogre::Light::getBoundingRadius | ( | void |  | ) | const
| inlineoverridevirtual

Retrieves the radius of the origin-centered bounding sphere for this object.

Implements Ogre::MovableObject.

## ◆ getBoundingBox()

const AxisAlignedBox & Ogre::Light::getBoundingBox | ( | void |  | ) | const
| overridevirtual

Retrieves the local axis-aligned bounding box for this object.

This bounding box is in local coordinates.

Implements Ogre::MovableObject.

## ◆ _updateRenderQueue()

void Ogre::Light::_updateRenderQueue | ( | RenderQueue * | queue | ) |
| inlineoverridevirtual

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Implements Ogre::MovableObject.

## ◆ getMovableType()

const String & Ogre::Light::getMovableType | ( | void |  | ) | const
| overridevirtual

Returns the type name of this object.

Implements Ogre::MovableObject.

Reimplemented in Ogre::PCZLight.

## ◆ getDerivedPosition()

const Vector3 & Ogre::Light::getDerivedPosition | ( | bool | cameraRelativeIfSet = false | ) | const

Retrieves the position of the light including any transform from nodes it is attached to.

Parameters

  cameraRelativeIfSet | If set to true, returns data in camera-relative units if that's been set up (render use)

References getDerivedPosition().

Referenced by getDerivedPosition().

## ◆ getDerivedDirection()

const Vector3 & Ogre::Light::getDerivedDirection | ( | void |  | ) | const

Retrieves the direction of the light including any transform from nodes it is attached to.

References getDerivedDirection().

Referenced by getDerivedDirection().

## ◆ setVisible()

void Ogre::Light::setVisible | ( | bool | visible | ) |
| inline

Tells this object whether to be visible or not, if it has a renderable component.

Note
  An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visibility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visibility changes are best done using this method; large or more longer term changes are best done by detaching.

Although lights themselves are not 'visible', setting a light to invisible means it no longer affects the scene.

References Ogre::MovableObject::setVisible().

## ◆ getAs4DVector()

Vector4 Ogre::Light::getAs4DVector | ( | bool | cameraRelativeIfSet = false | ) | const

Returns the details of this light as a 4D vector.

Getting details of a light as a 4D vector can be useful for doing general calculations between different light types; for example the vector can represent both position lights (w=1.0f) and directional lights (w=0.0f) and be used in the same calculations.

Parameters

  cameraRelativeIfSet | If set to `true`, returns data in camera-relative units if that's been set up (render use).

## ◆ _getNearClipVolume()

virtual const PlaneBoundedVolume & Ogre::Light::_getNearClipVolume | ( | const Camera *const | cam | ) | const
| virtual

Internal method for calculating the 'near clip volume', which is the volume formed between the near clip rectangle of the camera and the light.

This volume is a pyramid for a point/spot light and a cuboid for a directional light. It can used to detect whether an object could be casting a shadow on the viewport. Note that the reference returned is to a shared volume which will be reused across calls to this method.

## ◆ _getFrustumClipVolumes()

virtual const PlaneBoundedVolumeList & Ogre::Light::_getFrustumClipVolumes | ( | const Camera *const | cam | ) | const
| virtual

Internal method for calculating the clip volumes outside of the frustum which can be used to determine which objects are casting shadow on the frustum as a whole.

Each of the volumes is a pyramid for a point/spot light and a cuboid for a directional light.

## ◆ getTypeFlags()

uint32 Ogre::Light::getTypeFlags | ( | void |  | ) | const
| overridevirtual

Override to return specific type flag.

Reimplemented from Ogre::MovableObject.

## ◆ createAnimableValue()

AnimableValuePtr Ogre::Light::createAnimableValue | ( | const String & | valueName | ) |
| overridevirtual

Create a reference-counted AnimableValuePtr for the named value.

You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Reimplemented from Ogre::AnimableObject.

## ◆ setCustomShadowCameraSetup()

void Ogre::Light::setCustomShadowCameraSetup | ( | const ShadowCameraSetupPtr & | customShadowSetup | ) |

Set this light to use a custom shadow camera when rendering texture shadows.

This changes the shadow camera setup for just this light, you can set the shadow camera setup globally using SceneManager::setShadowCameraSetup

See also
  ShadowCameraSetup

## ◆ resetCustomShadowCameraSetup()

void Ogre::Light::resetCustomShadowCameraSetup | ( | void |  | ) |

Reset the shadow camera setup to the default.

See also
  ShadowCameraSetup

## ◆ getCustomShadowCameraSetup()

const ShadowCameraSetupPtr & Ogre::Light::getCustomShadowCameraSetup | ( | void |  | ) | const

Return a pointer to the custom shadow camera setup (null means use SceneManager global version).

## ◆ visitRenderables()

void Ogre::Light::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = false )
| overridevirtual

Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.

Parameters

  visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.

Implements Ogre::MovableObject.

## ◆ _getIndexInFrame()

size_t Ogre::Light::_getIndexInFrame | ( |  | ) | const
| inline

Returns the index at which this light is in the current render.

Lights will be present in the in a list for every renderable, detected and sorted appropriately, and sometimes it's useful to know what position in that list a given light occupies. This can vary from frame to frame (and object to object) so you should not use this value unless you're sure the context is correct.

## ◆ _notifyIndexInFrame()

void Ogre::Light::_notifyIndexInFrame | ( | size_t | i | ) |
| inline

## ◆ setShadowFarDistance()

void Ogre::Light::setShadowFarDistance | ( | Real | distance | ) |

Sets the maximum distance away from the camera that shadows by this light will be visible.

Shadow techniques can be expensive, therefore it is a good idea to limit them to being rendered close to the camera if possible, and to skip the expense of rendering shadows for distance objects. This method allows you to set the distance at which shadows casters will be culled.

## ◆ resetShadowFarDistance()

void Ogre::Light::resetShadowFarDistance | ( | void |  | ) |

Tells the light to use the shadow far distance of the SceneManager.

## ◆ getShadowFarDistance()

Real Ogre::Light::getShadowFarDistance | ( | void |  | ) | const

Returns the maximum distance away from the camera that shadows by this light will be visible.

## ◆ getShadowFarDistanceSquared()

Real Ogre::Light::getShadowFarDistanceSquared | ( | void |  | ) | const

## ◆ setShadowNearClipDistance()

void Ogre::Light::setShadowNearClipDistance | ( | Real | nearClip | ) |
| inline

Set the near clip plane distance to be used by the shadow camera, if this light casts texture shadows.

Parameters

  nearClip | The distance, or -1 to use the main camera setting.

## ◆ getShadowNearClipDistance()

Real Ogre::Light::getShadowNearClipDistance | ( |  | ) | const
| inline

Returns the near clip plane distance to be used by the shadow camera, if this light casts texture shadows.

May be zero if the light doesn't have it's own near distance set; use _deriveShadowNearDistance for a version guaranteed to give a result.

## ◆ _deriveShadowNearClipDistance()

Real Ogre::Light::_deriveShadowNearClipDistance | ( | const Camera * | maincam | ) | const

Derive a shadow camera near distance from either the light, or from the main camera if the light doesn't have its own setting.

## ◆ setShadowFarClipDistance()

void Ogre::Light::setShadowFarClipDistance | ( | Real | farClip | ) |
| inline

Set the far clip plane distance to be used by the shadow camera, if this light casts texture shadows.

This is different from the 'shadow far distance', which is always measured from the main camera. This distance is the far clip plane of the light camera.

Parameters

  farClip | The distance, or -1 to use the main camera setting.

## ◆ getShadowFarClipDistance()

Real Ogre::Light::getShadowFarClipDistance | ( |  | ) | const
| inline

Returns the far clip plane distance to be used by the shadow camera, if this light casts texture shadows.

May be zero if the light doesn't have it's own far distance set; use _deriveShadowfarDistance for a version guaranteed to give a result.

## ◆ _deriveShadowFarClipDistance() [1/2]

Real Ogre::Light::_deriveShadowFarClipDistance | ( |  | ) | const

Derive a shadow camera far distance.

Referenced by _deriveShadowFarClipDistance().

## ◆ _deriveShadowFarClipDistance() [2/2]

Real Ogre::Light::_deriveShadowFarClipDistance | ( | const Camera * |  | ) | const
| inline

Deprecated
  use _deriveShadowFarClipDistance()

References _deriveShadowFarClipDistance().

## ◆ _setCameraRelative()

void Ogre::Light::_setCameraRelative | ( | Camera * | cam | ) |

Set the camera which this light should be relative to, for camera-relative rendering.

## ◆ setCustomParameter()

void Ogre::Light::setCustomParameter | ( | uint16 | index,
|  | const Vector4f & | value )

Sets a custom parameter for this Light, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Calling this method simply associates a numeric index with a 4-dimensional value for this specific Light. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_LIGHT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters

  index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_LIGHT_CUSTOM entry, if that is used.
  value | The value to associate.

## ◆ getCustomParameter()

const Vector4f & Ogre::Light::getCustomParameter | ( | uint16 | index | ) | const

Returns the custom value associated with this Light at the given index.

Parameters

  index | Index of the parameter to retrieve

See also
  setCustomParameter for full details.

## ◆ _updateCustomGpuParameter()

virtual void Ogre::Light::_updateCustomGpuParameter | ( | uint16 | paramIndex,
|  | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params ) const
| virtual

Update a custom GpuProgramParameters constant which is derived from information only this Light knows.

This method allows a Light to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_LIGHT_CUSTOM, and to allow there to be more than one of these per Light, the 'data' field on the auto parameter will identify which parameter is being updated and on which light. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters

  paramIndex | The index of the constant being updated
  constantEntry | The auto constant entry from the program parameters
  params | The parameters object which this method should call to set the updated parameters.

## ◆ isInLightRange() [1/2]

bool Ogre::Light::isInLightRange | ( | const Ogre::Sphere & | sphere | ) | const

Check whether a sphere is included in the lighted area of the light.

Note
  The function trades accuracy for efficiency. As a result you may get false-positives (The function should not return any false-negatives).

## ◆ isInLightRange() [2/2]

bool Ogre::Light::isInLightRange | ( | const Ogre::AxisAlignedBox & | container | ) | const

Check whether a bounding box is included in the lighted area of the light.

Note
  The function trades accuracy for efficiency. As a result you may get false-positives (The function should not return any false-negatives).

## Member Data Documentation

## ◆ tempSquareDist

Real Ogre::Light::tempSquareDist

Temp tag used for sorting.

The documentation for this class was generated from the following file:

- OgreLight.h